package thegame.client;

import java.net.*;
import java.io.*;
import thegame.shared.*;


/**
 * The connection to GameServer on the GameClient side.
 * @author Erki Suurjaak
 * @version 0.99 (2000/08/28)
 */
public class GameClientConnection
  extends GameConnection
{
  /** The GameClient that gets the received messages. */  
  protected GameClient
  gameClient;

  /**
   * Constructs a GameClientConnection on the specified socket and binds it to the specified GameClient. Also starts the thread.
   * @param socket the socket to be used
   * @param gameClient the GameClient the GameClientConnection sends messages to
   * @throws IOException if an I/O error occurs when constructing the superclass
   */
  public
  GameClientConnection(Socket socket, GameClient gameClient)
  throws IOException
    {
      super(socket);
      this.gameClient = gameClient;
      start();
    }


  /*
   * The socket is listened on and if a message arrives, it is sent to gameClient.
   */
  public void
  run()
    {
      while (isRunning)
        {
          try
            {
              sleep(400);
              String str = in.readLine();
              gameClient.handleMessage(str);
            }
          catch (Exception e)
            {
            } 
        }
    }


}
