package thegame.client;

import java.awt.*;
import javax.swing.*;


/**
 * Holds the constants used by GameClient.
 * @author Erki Suurjaak
 * @version 0.99 (2000/08/28)
 */
public interface GameClientConstants
{
  /**
   * Holds the constants used by GameScreen.
   * @author Erki Suurjaak
   */
  public interface StartScreenConstants
  {
    public static final int
    ENTER_NAME_FIELD_COLS = 15,
    NUMBER_OF_BUTTONS = 4,
    BUTTON_PANEL_ROWS = 3,
    BUTTON_PANEL_COLS = 1,
    ACCEPT_NAME_BUTTON_NUMBER = 0,
    JOIN_GAME_BUTTON_NUMBER = 2,
    CREATE_GAME_BUTTON_NUMBER = 1,
    PLAYER_NAMES_LIST_ROWS = 16,
    NUMBER_OF_COMPONENTS_TO_DISABLE = 5;

    /** The buttons that are grouped together. */
    public static final int[]
    GAME_BUTTONS = {1, 2, 3, };

    /** The state of the buttons at startup. */
    public static final boolean[]
    ENABLED_AT_STARTUP = {true, false, false, true, };

    public static final char
    ACCEPT_NAME_BUTTON_MNEMONIC = 'a',
    ENTER_NAME_FIELD_MNEMONIC = 'n',
    CREATE_GAME_BUTTON_MNEMONIC = 'c',
    JOIN_GAME_BUTTON_MNEMONIC = 'j',
    QUIT_GAME_BUTTON_MNEMONIC = 'q';

    public static final String
    START_SCREEN_PICTURE_PATH = "images/startScreenPicture.gif",
    PLAYER_NAME_NOT_OK_MESSAGE_TITLE = "Error in entered name",
    JOIN_GAME_FAILED_MESSAGE_TITLE = "Join failed",
    JOIN_GAME_FAILED_MESSAGE_TEXT = "Join game failed - the selected player is not available for join.",
    CREATE_GAME_BUTTON_CLICK_MESSAGE_TITLE = "Create game",
    CREATE_GAME_BUTTON_CLICK_MESSAGE_TEXT = "Make a choice :",
    ACCEPT_NAME_BUTTON_LABEL = "Accept name",
    CREATE_GAME_BUTTON_LABEL = "Create game",
    JOIN_GAME_BUTTON_LABEL = "Join game",
    QUIT_GAME_BUTTON_LABEL = "Quit game",
    ACCEPT_NAME_BUTTON_TOOL_TIP = "Accepts your name",
    CREATE_GAME_BUTTON_TOOL_TIP = "Creates a new game and inserts it among the waiting games",
    JOIN_GAME_BUTTON_TOOL_TIP = "Joins the selected game",
    QUIT_GAME_BUTTON_TOOL_TIP = "Quits the game",
    ENTER_NAME_FIELD_LABEL_TEXT = " Your name : ",
    PLAYER_NAMES_LIST_LABEL_TEXT = " Available players to join : ",
    PLAYER_NAMES_LIST_PROTOTYPE_VALUE = "1234567890123456789012345",
    PICTURE_AND_COPYRIGHT_LABEL_TEXT = "<HTML><B><FONT SIZE=4>" +
                                       "The Game</FONT>, &copy; 2000 Erki Suurjaak<BR>" +
                                       "Written in Java 2 <BR>" +
                                       "Last modified : 07.08.2000" +
                                       "</B></HTML>",
    INFORMATION_LABEL_TEXT = "<HTML><B>" +
                             "The Game is similar to tic-tac-toe.<BR>" +
                             "The main difference is in the size of the<BR>" +
                             "gamefield - it is 25 by 25 squares.<BR>" +
                             "Also the number of circles or crosses in a<BR>" +
                             "row required for victory is 5.<BR>" +
                             "<BR>" +
                             "Select a player from the list and press<BR>" +
                             "<I>" + JOIN_GAME_BUTTON_LABEL + "</I> to join an already created<BR>" +
                             "game, or press <I>" + CREATE_GAME_BUTTON_LABEL + "</I> to create a<BR>" +
                             "game yourself. Note that you cannot join or<BR>" +
                             "create a game before you enter your name." +
                             "</B></HTML>";


    public static final String[]
    BUTTON_LABELS = {ACCEPT_NAME_BUTTON_LABEL, CREATE_GAME_BUTTON_LABEL,
                     JOIN_GAME_BUTTON_LABEL, QUIT_GAME_BUTTON_LABEL, },
    BUTTON_TOOL_TIPS = {ACCEPT_NAME_BUTTON_TOOL_TIP, CREATE_GAME_BUTTON_TOOL_TIP,
                        JOIN_GAME_BUTTON_TOOL_TIP, QUIT_GAME_BUTTON_TOOL_TIP, },
    CREATE_GAME_BUTTON_CLICK_MESSAGE_OPTIONS = {"Draw circles", "Draw crosses", "Cancel"};

    public static final char[]
    BUTTON_MNEMONICS = {ACCEPT_NAME_BUTTON_MNEMONIC, CREATE_GAME_BUTTON_MNEMONIC,
                        JOIN_GAME_BUTTON_MNEMONIC, QUIT_GAME_BUTTON_MNEMONIC, };

    public static final Font
    LABELS_FONT = new Font("SansSerif", Font.BOLD, 12);

    public static final Insets
    PLAYER_NAMES_LIST_INSETS = new Insets(5, 5, 5, 5),
    BUTTON_INSETS = new Insets(1, 5, 1, 5);

    /** The picture shown in StartScreen. */
    public static final ImageIcon
    START_SCREEN_PICTURE = GameClient.getImageIcon(START_SCREEN_PICTURE_PATH);
 };



  /**
   * Holds the constants used by StartScreen.
   * @author Erki Suurjaak
   */
  public interface GameScreenConstants
  {
    public static final String
    NEW_GAME_BUTTON_LABEL = "New game",
    NEW_GAME_BUTTON_TOOL_TIP = "Starts a new game",
    SURRENDER_GAME_BUTTON_LABEL = "Surrender",
    SURRENDER_GAME_BUTTON_TOOL_TIP = "Surrenders the current game",
    WAIT_FOR_NEW_PLAYER_BUTTON_LABEL = "Wait for new player",
    WAIT_FOR_NEW_PLAYER_BUTTON_TOOL_TIP = "Drops the remote player, if any, and makes you available for join",
    QUIT_TO_START_SCREEN_BUTTON_LABEL = "Quit to start screen",
    QUIT_TO_START_SCREEN_BUTTON_TOOL_TIP = "Drops the remote player, if any, and quits to start screen",
    QUIT_GAME_BUTTON_LABEL = "Quit game",
    QUIT_GAME_BUTTON_TOOL_TIP = "Quits the game",
    SEND_MESSAGE_BUTTON_LABEL = "Send",
    SEND_MESSAGE_BUTTON_TOOL_TIP = "Sends the entered message to remote player",
    CLEAR_MESSAGE_AREA_LABEL = "Clear",
    CLEAR_MESSAGE_AREA_TOOL_TIP = "Clears the sent and received messages",

    ENTER_MESSAGE_FIELD_LABEL_LABEL = "Enter message :",

    TIME_START_LABEL = "00:00:00",
    SCORE_START_LABEL = "0",
    MESSAGE_AREA_LABEL = " Sent and received messages ",
    SEND_MESSAGE_AREA_LABEL = " Send message ",

    SHOW_LOCAL_PLAYER_LAST_MOVE_CHECK_BOX_LABEL = "Show my last move",
    SHOW_REMOTE_PLAYER_LAST_MOVE_CHECK_BOX_LABEL = "Show remote player's last move",
    SHOW_LOCAL_PLAYER_LAST_MOVE_CHECK_BOX_TOOL_TIP = "Makes your last move highlighted",
    SHOW_REMOTE_PLAYER_LAST_MOVE_CHECK_BOX_TOOL_TIP = "Makes the remote player's last move highlighted",

    PLAYER_LOST_MESSAGE_TEXT = "You lost the game.",
    PLAYER_LOST_MESSAGE_TITLE = "Game lost",
    PLAYER_QUIT_MESSAGE_TEXT = "The remote player quit the game.",
    PLAYER_QUIT_MESSAGE_TITLE = "Remote player",
    PLAYER_SURRENDERED_MESSAGE_TEXT = "The remote player surrendered.",
    PLAYER_SURRENDERED_MESSAGE_TITLE = "Game won.",
    PLAYER_WON_MESSAGE_TEXT = "You won the game.",
    PLAYER_WON_MESSAGE_TITLE = "Game won.",
    PLAYER_REQUESTED_NEW_GAME_MESSAGE_TEXT = "The remote player wants to start a new game. Accept?",
    PLAYER_REQUESTED_NEW_GAME_MESSAGE_TITLE = "New game",
    PLAYER_ACCEPTED_NEW_GAME_MESSAGE_TEXT = "The remote player accepted a new game.",
    PLAYER_ACCEPTED_NEW_GAME_MESSAGE_TITLE = "New game",
    PLAYER_REFUSED_NEW_GAME_MESSAGE_TEXT = "The remote player refused a new game.",
    PLAYER_REFUSED_NEW_GAME_MESSAGE_TITLE = "New game",
    PLAYER_QUIT_TO_START_SCREEN_MESSAGE_TEXT = "The remote player quit to start screen.",
    PLAYER_QUIT_TO_START_SCREEN_MESSAGE_TITLE = "Remote player",
    NEW_PLAYER_MESSAGE_TEXT = "A player has joined your game.",
    NEW_PLAYER_MESSAGE_TITLE = "New player",
    PLAYER_DROPPED_MESSAGE_TEXT = "The remote player dropped you to wait for a new player.",
    PLAYER_DROPPED_MESSAGE_TITLE = "Remote player",

    NEW_GAME_BUTTON_CLICK_MESSAGE_TEXT = "Are you sure you want to start a new Game?",
    NEW_GAME_BUTTON_CLICK_MESSAGE_TITLE = "Confirm new game",
    SURRENDER_GAME_BUTTON_CLICK_MESSAGE_TEXT = "Are you sure you want to surrender this Game?",
    SURRENDER_GAME_BUTTON_CLICK_MESSAGE_TITLE = "Confirm surrender",
    WAIT_FOR_NEW_PLAYER_BUTTON_CLICK_MESSAGE_TEXT = "Are you sure you want to drop this player, if any, and wait for a new one?",
    WAIT_FOR_NEW_PLAYER_BUTTON_CLICK_MESSAGE_TITLE = "Confirm new player",
    QUIT_TO_START_SCREEN_BUTTON_CLICK_MESSAGE_TEXT = "Are you sure you want to quit to start screen?",
    QUIT_TO_START_SCREEN_BUTTON_CLICK_MESSAGE_TITLE = "Confirm quit",
    QUIT_GAME_BUTTON_CLICK_MESSAGE_TEXT = "Are you sure you want to quit The Game?",
    QUIT_GAME_BUTTON_CLICK_MESSAGE_TITLE = "Confirm quit",

    REMOTE_PLAYER_START_LABEL = "(NO PLAYER)",

    PLAYER_CIRCLED_ICON_PATH = "images/playerCircledIcon.gif",
    PLAYER_CROSSED_ICON_PATH = "images/playerCrossedIcon.gif",
    PLAYER_HIGHLIGHTED_CIRCLED_ICON_PATH = "images/playerHighlightedCircledIcon.gif",
    PLAYER_HIGHLIGHTED_CROSSED_ICON_PATH = "images/playerHighlightedCrossedIcon.gif",

    NEW_LINE = "\n";

    static final String[]
    BUTTON_LABELS = {NEW_GAME_BUTTON_LABEL, SURRENDER_GAME_BUTTON_LABEL, WAIT_FOR_NEW_PLAYER_BUTTON_LABEL, 
                     QUIT_TO_START_SCREEN_BUTTON_LABEL, QUIT_GAME_BUTTON_LABEL, SEND_MESSAGE_BUTTON_LABEL, 
                     CLEAR_MESSAGE_AREA_LABEL},
    BUTTON_TOOL_TIPS = {NEW_GAME_BUTTON_TOOL_TIP, SURRENDER_GAME_BUTTON_TOOL_TIP, WAIT_FOR_NEW_PLAYER_BUTTON_TOOL_TIP,
                        QUIT_TO_START_SCREEN_BUTTON_TOOL_TIP, QUIT_GAME_BUTTON_TOOL_TIP, 
                        SEND_MESSAGE_BUTTON_TOOL_TIP, CLEAR_MESSAGE_AREA_TOOL_TIP},
    CHECK_BOX_LABELS = {SHOW_LOCAL_PLAYER_LAST_MOVE_CHECK_BOX_LABEL, SHOW_REMOTE_PLAYER_LAST_MOVE_CHECK_BOX_LABEL},
    CHECK_BOX_TOOL_TIPS = {SHOW_LOCAL_PLAYER_LAST_MOVE_CHECK_BOX_TOOL_TIP, SHOW_REMOTE_PLAYER_LAST_MOVE_CHECK_BOX_TOOL_TIP};


    static final char
    NEW_GAME_BUTTON_MNEMONIC = 'n',
    SURRENDER_GAME_BUTTON_MNEMONIC = 's',
    WAIT_FOR_NEW_PLAYER_BUTTON_MNEMONIC = 'w',
    QUIT_TO_START_SCREEN_BUTTON_MNEMONIC = 't',
    QUIT_GAME_BUTTON_MNEMONIC = 'q',
    SEND_MESSAGE_BUTTON_MNEMONIC = 'd',
    CLEAR_MESSAGE_AREA_MNEMONIC = 'c',
    SHOW_LOCAL_PLAYER_LAST_MOVE_CHECK_BOX_MNEMONIC = 'm',
    SHOW_REMOTE_PLAYER_LAST_MOVE_CHECK_BOX_MNEMONIC = 'r',
    SEND_MESSAGE_BUTTON_LABEL_MNEMONIC = 'g';


    static final char[]
    BUTTON_MNEMONICS = {NEW_GAME_BUTTON_MNEMONIC, SURRENDER_GAME_BUTTON_MNEMONIC,
                        WAIT_FOR_NEW_PLAYER_BUTTON_MNEMONIC, QUIT_TO_START_SCREEN_BUTTON_MNEMONIC, 
                        QUIT_GAME_BUTTON_MNEMONIC, SEND_MESSAGE_BUTTON_MNEMONIC, 
                        CLEAR_MESSAGE_AREA_MNEMONIC},
    CHECK_BOX_MNEMONICS = {SHOW_LOCAL_PLAYER_LAST_MOVE_CHECK_BOX_MNEMONIC, 
                           SHOW_REMOTE_PLAYER_LAST_MOVE_CHECK_BOX_MNEMONIC};

    static final int
    BUTTON_PANEL_WIDTH = 50,
    BUTTON_PANEL_HEIGHT = 120,
    BUTTON_PANEL_ROWS = 3,
    BUTTON_PANEL_COLS = 2,

    SEND_MESSAGE_PANEL_COLS = 2,

    CHECK_BOX_PANEL_ROWS = 1,
    CHECK_BOX_PANEL_COLS = 2,
    
    PLAYER_LABELS_PANEL_ROWS = 5,
    PLAYER_LABELS_PANEL_COLS = 1,
    
    MESSAGE_AREA_ROWS = 7,
    MESSAGE_AREA_COLS = 24,
    SEND_MESSAGE_AREA_COLS = 21,

    NUMBER_OF_BUTTONS = 7,
    NUMBER_OF_GAME_RUNNING_BUTTONS = 1,
    NUMBER_OF_GAME_STATE_BUTTONS = 5,
    NUMBER_OF_PLAYER_EXISTS_BUTTONS = 4,
    NUMBER_OF_CHECK_BOXES = 2,

    SEND_MESSAGE_BUTTON_NUMBER = 5,
    WAIT_FOR_NEW_PLAYER_BUTTON_NUMBER = 2,
    CLEAR_MESSAGE_AREA_BUTTON_NUMBER = 6,
    SURRENDER_GAME_BUTTON_NUMBER = 1,
    NEW_GAME_BUTTON_NUMBER = 0,

    MESSAGE_AREA_MAXIMUM_LENGTH = 65536;


    static final int[]
    GAME_RUNNING_BUTTONS = {1},
    GAME_STATE_BUTTONS = {0, 1, 2, 3, 4},
    PLAYER_EXISTS_BUTTONS = {0, 1, 2, 5};

    public static final Insets
    CHECK_BOX_INSETS = new Insets(0, 0, 0, 0),
    BUTTON_INSETS = new Insets(1, 5, 1, 5),
    SEND_MESSAGE_BUTTON_INSETS = new Insets(1, 5, 1, 5),
    MESSAGE_AREA_INSETS = new Insets(1, 5, 1, 5);

    public static final Font
    PLAYER_LABELS_FONT = new Font("SansSerif", Font.BOLD, 12),
    PLAYER_SCORE_LABELS_FONT = new Font("SansSerif", Font.BOLD, 15),
    CHECK_BOXES_FONT = new Font("SansSerif", Font.PLAIN, 11);

    public static final ImageIcon
    PLAYER_CIRCLED_ICON = GameClient.getImageIcon(PLAYER_CIRCLED_ICON_PATH),
    PLAYER_CROSSED_ICON = GameClient.getImageIcon(PLAYER_CROSSED_ICON_PATH),
    PLAYER_HIGHLIGHTED_CIRCLED_ICON = GameClient.getImageIcon(PLAYER_HIGHLIGHTED_CIRCLED_ICON_PATH),
    PLAYER_HIGHLIGHTED_CROSSED_ICON = GameClient.getImageIcon(PLAYER_HIGHLIGHTED_CROSSED_ICON_PATH);
  };



  public static String
  HOST_PARAMETER_NAME = "HOST",
  HOST_PARAMETER_NOT_FOUND_TEXT = "Parameter HOST not specified.",
  PORT_PARAMETER_NAME = "PORT",
  NORMAL_TERMINATION_TEXT = "The Game was shut down successfully.",
  SERVER_SHUTDOWN_TEXT = "The game server was shut down.";


}
